import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["alignContent", "alignItems", "as", "children", "justifyContent", "gutter", "className", "colSpan", "l", "lOffset", "m", "mOffset", "s", "sOffset", "xl", "xlOffset", "xs", "xsOffset", "xxl", "xxlOffset", "xxs", "xxsOffset"];
import cx from 'classnames';
import PropTypes from 'prop-types';
import Injector from '@s-ui/react-primitive-injector';
import PolymorphicElement from '@s-ui/react-primitive-polymorphic-element';
import LayoutGridItem from './gridItem/index.js';
import { getGutterClassNames, transition } from './helpers.js';
import { ALIGN_CONTENT, ALIGN_ITEMS, BASE_CLASS, BREAKPOINTS, CELL_NUMBERS, GUTTER_VALUES, JUSTIFY_CONTENT } from './settings.js';
import { jsx as _jsx } from "react/jsx-runtime";
var LayoutGrid = function LayoutGrid(_ref) {
  var alignContent = _ref.alignContent,
    alignItems = _ref.alignItems,
    _ref$as = _ref.as,
    as = _ref$as === void 0 ? 'div' : _ref$as,
    children = _ref.children,
    justifyContent = _ref.justifyContent,
    gutter = _ref.gutter,
    className = _ref.className,
    colSpan = _ref.colSpan,
    l = _ref.l,
    lOffset = _ref.lOffset,
    m = _ref.m,
    mOffset = _ref.mOffset,
    s = _ref.s,
    sOffset = _ref.sOffset,
    xl = _ref.xl,
    xlOffset = _ref.xlOffset,
    xs = _ref.xs,
    xsOffset = _ref.xsOffset,
    xxl = _ref.xxl,
    xxlOffset = _ref.xxlOffset,
    xxs = _ref.xxs,
    xxsOffset = _ref.xxsOffset,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var classNames = cx("" + BASE_CLASS, Object.values(ALIGN_CONTENT).includes(alignContent) && BASE_CLASS + "--ac-" + alignContent, Object.values(ALIGN_ITEMS).includes(alignItems) && BASE_CLASS + "--ai-" + alignItems, Object.values(JUSTIFY_CONTENT).includes(justifyContent) && BASE_CLASS + "--jc-" + justifyContent, getGutterClassNames(gutter), className);
  return /*#__PURE__*/_jsx(PolymorphicElement, _extends({
    as: as,
    className: classNames
  }, props, {
    children: /*#__PURE__*/_jsx(Injector, {
      colSpan: colSpan,
      l: l,
      lOffset: lOffset,
      m: m,
      mOffset: mOffset,
      s: s,
      sOffset: sOffset,
      xl: xl,
      xlOffset: xlOffset,
      xs: xs,
      xsOffset: xsOffset,
      xxl: xxl,
      xxlOffset: xxlOffset,
      xxs: xxs,
      xxsOffset: xxsOffset,
      children: children
    })
  }));
};
LayoutGrid.displayName = 'LayoutGrid';
var DeprecatedLayoutGrid = function DeprecatedLayoutGrid(props) {
  return /*#__PURE__*/_jsx(LayoutGrid, _extends({}, transition(props)));
};
export default LayoutGrid;
export { DeprecatedLayoutGrid, LayoutGridItem, ALIGN_CONTENT as LayoutGridAlignContent, ALIGN_ITEMS as LayoutGridAlignItems, JUSTIFY_CONTENT as LayoutGridJustifyContent, GUTTER_VALUES as LayoutGridGutterValues, CELL_NUMBERS as LayoutGridCellNumbers, BREAKPOINTS as LayoutGridBreakpoints };